## copyparty-1.20.4.tar.gz

=== scripts/deps-docker/Makefile ===
self := $(dir $(abspath $(lastword $(MAKEFILE_LIST))))
vend := $(self)/../../copyparty/web/deps

# prefers podman-docker (optionally rootless) over actual docker/moby

all:
	cp -pv ../uncomment.py .

	docker build -t build-copyparty-deps .

	rm -rf $(vend)
	mkdir $(vend)

	echo "tar -cC /z dist" | \
	docker run --rm -i build-copyparty-deps:latest | \
	tar -xvC $(vend) --strip-components=1

	touch $(vend)/__init__.py
	chown -R `stat $(self) -c %u:%g` $(vend)

purge:
	-docker kill `docker ps -q`
	-docker rm   `docker ps -qa`
	-docker rmi  `docker images -qa`

sh:
	@printf "\n\033[1;31mopening a shell in the most recently created docker image\033[0m\n"
	docker run --rm -it `docker images -aq | head -n 1` /bin/ash

=== scripts/docker/Makefile ===
self := $(dir $(abspath $(lastword $(MAKEFILE_LIST))))

all:
	-service docker start
	-systemctl start docker
	
	rm -rf i
	mkdir i
	tar -cC../.. dist/copyparty-sfx.py bin/mtag | tar -xvCi
	
	docker build -t copyparty/min:latest -f Dockerfile.min .
	echo 'scale=1;'`docker save copyparty/min:latest | pigz -c | wc -c`/1024/1024 | bc

#	docker build -t copyparty/min-pip:latest -f Dockerfile.min.pip .
#	echo 'scale=1;'`docker save copyparty/min-pip:latest | pigz -c | wc -c`/1024/1024 | bc

	docker build -t copyparty/im:latest -f Dockerfile.im .
	echo 'scale=1;'`docker save copyparty/im:latest | pigz -c | wc -c`/1024/1024 | bc

	docker build -t copyparty/iv:latest -f Dockerfile.iv .
	echo 'scale=1;'`docker save copyparty/iv:latest | pigz -c | wc -c`/1024/1024 | bc

	docker build -t copyparty/ac:latest -f Dockerfile.ac .
	echo 'scale=1;'`docker save copyparty/ac:latest | pigz -c | wc -c`/1024/1024 | bc

	docker build -t copyparty/dj:latest -f Dockerfile.dj .
	echo 'scale=1;'`docker save copyparty/dj:latest | pigz -c | wc -c`/1024/1024 | bc

	docker image ls

min:
	rm -rf i
	mkdir i
	tar -cC../.. dist/copyparty-sfx.py bin/mtag | tar -xvCi

	podman build --squash --pull=always -t copyparty/min:latest -f Dockerfile.min .
	echo 'scale=1;'`podman save copyparty/min:latest | pigz -c | wc -c`/1024/1024 | bc

push:
	docker push copyparty/min
	docker push copyparty/im
	docker push copyparty/iv
	docker push copyparty/ac
	docker push copyparty/dj
	docker image tag copyparty/min:latest ghcr.io/9001/copyparty-min:latest
	docker image tag copyparty/im:latest ghcr.io/9001/copyparty-im:latest
	docker image tag copyparty/iv:latest ghcr.io/9001/copyparty-iv:latest
	docker image tag copyparty/ac:latest ghcr.io/9001/copyparty-ac:latest
	docker image tag copyparty/dj:latest ghcr.io/9001/copyparty-dj:latest
	docker push ghcr.io/9001/copyparty-min:latest
	docker push ghcr.io/9001/copyparty-im:latest
	docker push ghcr.io/9001/copyparty-iv:latest
	docker push ghcr.io/9001/copyparty-ac:latest
	docker push ghcr.io/9001/copyparty-dj:latest

clean:
	-docker kill `docker ps -q`
	-docker rm   `docker ps -qa`
	-docker rmi -f `docker images -a | awk '/<none>/{print$$3}'`

hclean:
	-docker kill `docker ps -q`
	-docker rm   `docker ps -qa`
	-docker rmi  `docker images -a | awk '!/^alpine/&&NR>1{print$$3}'`

purge:
	-docker kill `docker ps -q`
	-docker rm   `docker ps -qa`
	-docker rmi  `docker images -qa`

sh:
	@printf "\n\033[1;31mopening a shell in the most recently created docker image\033[0m\n"
	docker run --rm -it --entrypoint /bin/ash `docker images -aq | head -n 1`

=== scripts/docker/base/Makefile ===
self := $(dir $(abspath $(lastword $(MAKEFILE_LIST))))

all:
# 	build zlib-ng from source so we know how the sausage was made
#	(still only doing the archs which are officially supported/tested)

	podman build --arch amd64 -t localhost/cpp-zlibng-amd64:latest -f Dockerfile.zlibng .
	podman run --arch amd64 --rm --log-driver=none -i localhost/cpp-zlibng-amd64:latest tar -cC/z . | tar -xv

	podman build --arch arm64 -t localhost/cpp-zlibng-amd64:latest -f Dockerfile.zlibng .
	podman run --arch arm64 --rm --log-driver=none -i localhost/cpp-zlibng-amd64:latest tar -cC/z . | tar -xv

sh:
	@printf "\n\033[1;31mopening a shell in the most recently created docker image\033[0m\n"
	docker run --rm -it --entrypoint /bin/ash `docker images -aq | head -n 1`

=== contrib/package/arch/PKGBUILD ===
# Maintainer: icxes <dev.null@need.moe>
# Contributor: Morgan Adamiec <morganamilo@archlinux.org>
# NOTE: You generally shouldn't use this PKGBUILD on Arch, as it is mainly for testing purposes. Install copyparty using pacman instead.

pkgname=copyparty
pkgver="1.20.3"
pkgrel=1
pkgdesc="File server with accelerated resumable uploads, dedup, WebDAV, SFTP, FTP, TFTP, zeroconf, media indexer, thumbnails++"
arch=("any")
url="https://github.com/9001/${pkgname}"
license=('MIT')
depends=("bash" "python" "lsof" "python-jinja")
makedepends=("python-wheel" "python-setuptools" "python-build" "python-installer" "make" "pigz")
optdepends=("ffmpeg: thumbnails for videos, images (slower) and audio, music tags"
            "cfssl: generate TLS certificates on startup"
            "python-mutagen: music tags (alternative)"
            "python-paramiko: sftp server",
            "python-pillow: thumbnails for images"
            "python-pyvips: thumbnails for images (higher quality, faster, uses more ram)"
            "libkeyfinder: detection of musical keys"
            "python-pyopenssl: ftps functionality"
            "python-pyzmq: send zeromq messages from event-hooks"
            "python-argon2-cffi: hashed passwords in config"
)
source=("https://github.com/9001/${pkgname}/releases/download/v${pkgver}/${pkgname}-${pkgver}.tar.gz")
backup=("etc/${pkgname}/copyparty.conf" )
sha256sums=("894e2857852ddbbc8b9560732be1084f70010cdf1c5aac18ba9f72699f8ec933")

build() {
    cd "${srcdir}/${pkgname}-${pkgver}/copyparty/web"
    make

    cd "${srcdir}/${pkgname}-${pkgver}"
    python -m build --wheel --no-isolation
}

package() {
    cd "${srcdir}/${pkgname}-${pkgver}"
    python -m installer --destdir="$pkgdir" dist/*.whl

    install -dm755 "${pkgdir}/etc/${pkgname}"
    install -Dm755 "bin/prisonparty.sh" "${pkgdir}/usr/bin/prisonparty"
    install -Dm644 "contrib/systemd/${pkgname}.conf" "${pkgdir}/etc/${pkgname}/copyparty.conf"
    install -Dm644 "contrib/systemd/${pkgname}@.service" "${pkgdir}/usr/lib/systemd/system/${pkgname}@.service"
    install -Dm644 "contrib/systemd/${pkgname}-user.service" "${pkgdir}/usr/lib/systemd/user/${pkgname}.service"
    install -Dm644 "contrib/systemd/prisonparty@.service" "${pkgdir}/usr/lib/systemd/system/prisonparty@.service"
    install -Dm644 "contrib/systemd/index.md" "${pkgdir}/var/lib/${pkgname}-jail/README.md"
    install -Dm644 "LICENSE" "${pkgdir}/usr/share/licenses/${pkgname}/LICENSE"
}

=== contrib/package/makedeb-mpr/PKGBUILD ===
# Contributor: Beethoven <beethovenisadog@protonmail.com>


pkgname=copyparty
pkgver=1.20.3
pkgrel=1
pkgdesc="File server with accelerated resumable uploads, dedup, WebDAV, SFTP, FTP, TFTP, zeroconf, media indexer, thumbnails++"
arch=("any")
url="https://github.com/9001/${pkgname}"
license=('MIT')
depends=("bash" "python3" "lsof" "python3-jinja2")
makedepends=("python3-wheel" "python3-setuptools" "python3-build" "python3-installer" "make" "pigz")
optdepends=("ffmpeg: thumbnails for videos, images (slower) and audio, music tags"
            "golang-cfssl: generate TLS certificates on startup"
            "python3-mutagen: music tags (alternative)"
            "python3-paramiko: sftp server"
            "python3-pil: thumbnails for images"
            "python3-openssl: ftps functionality"
            "python3-zmq: send zeromq messages from event-hooks"
            "python3-argon2: hashed passwords in config"
)
source=("https://github.com/9001/${pkgname}/releases/download/v${pkgver}/${pkgname}-${pkgver}.tar.gz")
backup=("/etc/${pkgname}.d/init" )
sha256sums=("894e2857852ddbbc8b9560732be1084f70010cdf1c5aac18ba9f72699f8ec933")

build() {
    cd "${srcdir}/${pkgname}-${pkgver}/copyparty/web"
    make

    cd "${srcdir}/${pkgname}-${pkgver}"
    python -m build --wheel --no-isolation
}

package() {
    cd "${srcdir}/${pkgname}-${pkgver}"
    python -m installer --destdir="$pkgdir" dist/*.whl

    install -dm755 "${pkgdir}/etc/${pkgname}.d"
    install -Dm755 "bin/prisonparty.sh" "${pkgdir}/usr/bin/prisonparty"
    install -Dm644 "contrib/package/makedeb-mpr/${pkgname}.conf" "${pkgdir}/etc/${pkgname}.d/init"
    install -Dm644 "contrib/package/makedeb-mpr/${pkgname}.service" "${pkgdir}/usr/lib/systemd/system/${pkgname}.service"
    install -Dm644 "contrib/package/makedeb-mpr/prisonparty.service" "${pkgdir}/usr/lib/systemd/system/prisonparty.service"
    install -Dm644 "contrib/package/makedeb-mpr/index.md" "${pkgdir}/var/lib/${pkgname}-jail/README.md"
    install -Dm644 "LICENSE" "${pkgdir}/usr/share/licenses/${pkgname}/LICENSE"
}
